#-----------------------------------------------------------------------------
#
#   A Python translation of the box.rb example.
#
#-----------------------------------------------------------------------------
# Original Google copyright notice:
#
# Copyright 2005-2008, Google, Inc.
#
# This software is provided as an example of using the Ruby interface
# to SketchUp.
#
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

def create_box():
    prompts = ("Width", "Height", "Depth")
    values = (6, 5, 4)
    results = UI.inputbox(prompts, values, "Box Dimensions")
    if not results:
        print '\n!returning!'
        return

    width, height, depth = [x * feet for x in results]
    model = Sketchup.active_model()
    model.start_operation("Create Box")
    entities = model.active_entities()
    group = entities.add_group()
    entities = group.entities()
    
    pts = [
        Point3d(0, 0, 0),
        Point3d(width, 0, 0),
        Point3d(width, depth, 0),
        Point3d(0, depth, 0)
    ]
    
    base = entities.add_face(*pts)
    Z_AXIS = Vector3d(0,0,1)
    if base.normal().dot(Z_AXIS) < 0:
        height = -height
    base.pushpull(height)
    model.commit_operation()

#
#   Build a menu
#
import menus
plug = menus.get_menu("Plugins")
sub = plug.add_submenu("SuPy Examples")
sub.add_item("Box", create_box)
